Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3337)
@@ -15,7 +15,7 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 2015-2018 Czech Technical University in Prague
 ! Copyright 2015-2018 Institute of Computer Science of the 
 !                     Czech Academy of Sciences, Prague
+! Copyright 2015-2018 Czech Technical University in Prague
 ! Copyright 1997-2018 Leibniz Universitaet Hannover
 !------------------------------------------------------------------------------!
@@ -28,4 +28,35 @@
 ! -----------------
 ! $Id$
+! - New RTM version 2.9: (Pavel Krc, Jaroslav Resler, ICS, Prague)
+!   added calculation of the MRT inside the RTM module
+!   MRT fluxes are consequently used in the new biometeorology module
+!   for calculation of biological indices (MRT, PET)
+!   Fixes of v. 2.5 and SVN trunk:
+!    - proper initialization of rad_net_l
+!    - make arrays nsurfs and surfstart TARGET to prevent some MPI problems
+!    - initialization of arrays used in MPI one-sided operation as 1-D arrays
+!      to prevent problems with some MPI/compiler combinations
+!    - fix indexing of target displacement in subroutine request_itarget to 
+!      consider nzub
+!    - fix LAD dimmension range in PCB calculation
+!    - check ierr in all MPI calls
+!    - use proper per-gridbox sky and diffuse irradiance
+!    - fix shading for reflected irradiance
+!    - clear away the residuals of "atmospheric surfaces" implementation
+!    - fix rounding bug in raytrace_2d introduced in SVN trunk
+! - New RTM version 2.5: (Pavel Krc, Jaroslav Resler, ICS, Prague)
+!   can use angular discretization for all SVF
+!   (i.e. reflected and emitted radiation in addition to direct and diffuse),
+!   allowing for much better scaling wih high resoltion and/or complex terrain
+! - Unite array grow factors
+! - Fix slightly shifted terrain height in raytrace_2d
+! - Use more efficient MPI_Win_allocate for reverse gridsurf index
+! - Fix random MPI RMA bugs on Intel compilers
+! - Fix approx. double plant canopy sink values for reflected radiation
+! - Fix mostly missing plant canopy sinks for direct radiation
+! - Fix discretization errors for plant canopy sink in diffuse radiation
+! - Fix rounding errors in raytrace_2d
+!
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -432,4 +463,6 @@
 !> @todo Output of other rrtm arrays (such as volume mixing ratios)
 !> @todo Check for mis-used NINT() calls in raytrace_2d
+!>       RESULT: Original was correct (carefully verified formula), the change
+!>               to INT broke raytracing      -- P. Krc
 !> @todo Optimize radiation_tendency routines
 !>
@@ -440,5 +473,5 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  dzw, hyp, nc, pt, q, ql, zu, zw, exner, d_exner
+        ONLY:  dzw, hyp, nc, pt, p, q, ql, u, v, w, zu, zw, exner, d_exner
 
     USE basic_constants_and_equations_mod,                                     &
@@ -735,6 +768,6 @@
                                              rrtm_swhr,      & !< RRTM output of shortwave radiation heating rate (K/d)
                                              rrtm_swhrc,     & !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
-                                             rrtm_dirdflux,  & !< RRTM output of incoming direct shortwave (W/m²) 
-                                             rrtm_difdflux     !< RRTM output of incoming diffuse shortwave (W/m²) 
+                                             rrtm_dirdflux,  & !< RRTM output of incoming direct shortwave (W/m) 
+                                             rrtm_difdflux     !< RRTM output of incoming diffuse shortwave (W/m) 
 
     REAL(wp), DIMENSION(1) ::                rrtm_aldif,     & !< surface albedo for longwave diffuse radiation
@@ -771,5 +804,5 @@
     INTEGER(iwp), PARAMETER                        ::  ndsvf = 2                          !< number of dimensions of real values in SVF
     INTEGER(iwp), PARAMETER                        ::  idsvf = 2                          !< number of dimensions of integer values in SVF
-    INTEGER(iwp), PARAMETER                        ::  ndcsf = 2                          !< number of dimensions of real values in CSF
+    INTEGER(iwp), PARAMETER                        ::  ndcsf = 1                          !< number of dimensions of real values in CSF
     INTEGER(iwp), PARAMETER                        ::  idcsf = 2                          !< number of dimensions of integer values in CSF
     INTEGER(iwp), PARAMETER                        ::  kdcsf = 4                          !< number of dimensions of integer values in CSF calculation array
@@ -779,5 +812,5 @@
     INTEGER(iwp), PARAMETER                        ::  ix = 4                             !< position of i-index in surfl and surf
 
-    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 16                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
+    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 10                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
 
     INTEGER(iwp), PARAMETER                        ::  iup_u    = 0                       !< 0 - index of urban upward surface (ground or roof)
@@ -794,14 +827,7 @@
     INTEGER(iwp), PARAMETER                        ::  iwest_l  = 10                      !< 10- index of land westward facing wall
 
-    INTEGER(iwp), PARAMETER                        ::  iup_a    = 11                      !< 11- index of atm. cell ubward virtual surface
-    INTEGER(iwp), PARAMETER                        ::  idown_a  = 12                      !< 12- index of atm. cell downward virtual surface
-    INTEGER(iwp), PARAMETER                        ::  inorth_a = 13                      !< 13- index of atm. cell northward facing virtual surface
-    INTEGER(iwp), PARAMETER                        ::  isouth_a = 14                      !< 14- index of atm. cell southward facing virtual surface
-    INTEGER(iwp), PARAMETER                        ::  ieast_a  = 15                      !< 15- index of atm. cell eastward facing virtual surface
-    INTEGER(iwp), PARAMETER                        ::  iwest_a  = 16                      !< 16- index of atm. cell westward facing virtual surface
-
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1,0, 0,0, 0,1,-1/)   !< surface normal direction x indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0,0, 0,1,-1,0, 0/)   !< surface normal direction y indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0,1,-1,0, 0,0, 0/)   !< surface normal direction z indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1/)   !< surface normal direction x indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0/)   !< surface normal direction y indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0/)   !< surface normal direction z indices
                                                                                           !< parameter but set in the code
 
@@ -816,11 +842,13 @@
 
 !-- indices and sizes of urban and land surface models
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surfl            !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surf             !< coordinates of i-th surface in grid - surf[:,k] = [d, z, y, x]
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfl_l          !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surf_l           !< coordinates of i-th surface in grid - surf[:,k] = [d, z, y, x]
+    INTEGER(iwp), DIMENSION(:,:), POINTER          ::  surfl            !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
+    INTEGER(iwp), DIMENSION(:,:), POINTER          ::  surf             !< coordinates of i-th surface in grid - surf[:,k] = [d, z, y, x]
     INTEGER(iwp)                                   ::  nsurfl           !< number of all surfaces in local processor
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nsurfs           !< array of number of all surfaces in individual processors
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  nsurfs           !< array of number of all surfaces in individual processors
     INTEGER(iwp)                                   ::  nsurf            !< global number of surfaces in index array of surfaces (nsurf = proc nsurfs)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  surfstart        !< starts of blocks of surfaces for individual processors in array surf
-                                                                        !< respective block for particular processor is surfstart[iproc]+1 : surfstart[iproc+1]
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfstart        !< starts of blocks of surfaces for individual processors in array surf (indexed from 1)
+                                                                        !< respective block for particular processor is surfstart[iproc+1]+1 : surfstart[iproc+1]+nsurfs[iproc+1]
 
 !-- block variables needed for calculation of the plant canopy model inside the urban surface model
@@ -835,6 +863,12 @@
 
 !-- configuration parameters (they can be setup in PALM config)
-    LOGICAL                                        ::  rma_lad_raytrace = .FALSE.         !< use MPI RMA to access LAD for raytracing (instead of global array)
-    LOGICAL                                        ::  mrt_factors = .FALSE.              !< whether to generate MRT factor files during init
+    LOGICAL                                        ::  raytrace_mpi_rma = .TRUE.          !< use MPI RMA to access LAD and gridsurf from remote processes during raytracing
+    LOGICAL                                        ::  read_svf_on_init = .FALSE.         !< flag parameter indicating wheather SVFs will be read from a file at initialization
+    LOGICAL                                        ::  write_svf_on_init = .FALSE.        !< flag parameter indicating wheather SVFs will be written out to a file
+    LOGICAL                                        ::  rad_angular_discretization = .TRUE.!< whether to use fixed resolution discretization of view factors for 
+                                                                                          !< reflected radiation (as opposed to all mutually visible pairs)
+    INTEGER(iwp)                                   ::  mrt_nlevels = 0                    !< number of vertical boxes above surface for which to calculate MRT
+    LOGICAL                                        ::  mrt_skip_roof = .TRUE.             !< do not calculate MRT above roof surfaces
+    LOGICAL                                        ::  mrt_include_sw = .TRUE.            !< should MRT calculation include SW radiation as well?
     INTEGER(iwp)                                   ::  nrefsteps = 0                      !< number of reflection steps to perform
     REAL(wp), PARAMETER                            ::  ext_coef = 0.6_wp                  !< extinction coefficient (a.k.a. alpha)
@@ -874,9 +908,8 @@
         INTEGER(iwp)                               :: isurfs            !< 
         REAL(wp)                                   :: rsvf              !< 
-        REAL(wp)                                   :: rtransp           !< 
     END TYPE
 
 !-- arrays storing the values of USM
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  svfsurf          !< svfsurf[:,isvf] = index of source and target surface for svf[isvf]
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  svfsurf          !< svfsurf[:,isvf] = index of target and source surface for svf[isvf]
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  svf              !< array of shape view factors+direct irradiation factors for local surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins          !< array of sw radiation falling to local surface after i-th reflection
@@ -892,4 +925,20 @@
     INTEGER(iwp)                                   ::  ndsidir          !< number of apparent solar directions used
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  dsidir_rev       !< dsidir_rev[ielev,iazim] = i for dsidir or -1 if not present
+
+    INTEGER(iwp)                                   ::  nmrtbl           !< No. of local grid boxes for which MRT is calculated
+    INTEGER(iwp)                                   ::  nmrtf            !< number of MRT factors for local processor
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  mrtbl            !< coordinates of i-th local MRT box - surfl[:,i] = [z, y, x]
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  mrtfsurf         !< mrtfsurf[:,imrtf] = index of target MRT box and source surface for mrtf[imrtf]
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtf             !< array of MRT factors for each local MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtft            !< array of MRT factors including transparency for each local MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtsky           !< array of sky view factor for each local MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtskyt          !< array of sky view factor including transparency for each local MRT box
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  mrtdsit          !< array of direct solar transparencies for each local MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtinsw          !< mean SW radiant flux for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtinlw          !< mean LW radiant flux for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrt              !< mean radiant temperature for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtinsw_av       !< time average mean SW radiant flux for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrtinlw_av       !< time average mean LW radiant flux for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  mrt_av           !< time average mean radiant temperature for each MRT box
 
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw         !< array of sw radiation falling to local surface including radiation from reflections
@@ -920,10 +969,14 @@
     TYPE(t_svf), DIMENSION(:), POINTER             ::  asvf             !< pointer to growing svc array
     TYPE(t_csf), DIMENSION(:), POINTER             ::  acsf             !< pointer to growing csf array
+    TYPE(t_svf), DIMENSION(:), POINTER             ::  amrtf            !< pointer to growing mrtf array
     TYPE(t_svf), DIMENSION(:), ALLOCATABLE, TARGET ::  asvf1, asvf2     !< realizations of svf array
     TYPE(t_csf), DIMENSION(:), ALLOCATABLE, TARGET ::  acsf1, acsf2     !< realizations of csf array
+    TYPE(t_svf), DIMENSION(:), ALLOCATABLE, TARGET ::  amrtf1, amrtf2   !< realizations of mftf array
     INTEGER(iwp)                                   ::  nsvfla           !< dimmension of array allocated for storage of svf in local processor
     INTEGER(iwp)                                   ::  ncsfla           !< dimmension of array allocated for storage of csf in local processor
-    INTEGER(iwp)                                   ::  msvf, mcsf       !< mod for swapping the growing array
-    INTEGER(iwp), PARAMETER                        ::  gasize = 10000   !< initial size of growing arrays
+    INTEGER(iwp)                                   ::  nmrtfa           !< dimmension of array allocated for storage of mrt
+    INTEGER(iwp)                                   ::  msvf, mcsf, mmrtf!< mod for swapping the growing array
+    INTEGER(iwp), PARAMETER                        ::  gasize = 100000  !< initial size of growing arrays
+    REAL(wp), PARAMETER                            ::  grow_factor = 1.4_wp !< growth factor of growing arrays
     REAL(wp)                                       ::  dist_max_svf = -9999.0 !< maximum distance to calculate the minimum svf to be considered. It is
                                                                         !< used to avoid very small SVFs resulting from too far surfaces with mutual visibility
@@ -932,5 +985,7 @@
                                                                         !< needed only during calc_svf but must be here because it is
                                                                         !< shared between subroutines calc_svf and raytrace
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< index of local pcb[k,j,i]
+    INTEGER(iwp), DIMENSION(:,:,:,:), POINTER      ::  gridsurf         !< reverse index of local surfl[d,k,j,i] (for case rad_angular_discretization)
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< reverse index of local pcbl[k,j,i]
+    INTEGER(iwp), PARAMETER                        ::  nsurf_type_u = 6 !< number of urban surf types (used in gridsurf)
 
 !-- temporary arrays for calculation of csf in raytracing
@@ -942,6 +997,9 @@
     INTEGER(kind=MPI_ADDRESS_KIND), &
                   DIMENSION(:), ALLOCATABLE        ::  lad_disp         !< array of displaycements of lad in local array of proc lad_ip
+    INTEGER(iwp)                                   ::  win_lad          !< MPI RMA window for leaf area density
+    INTEGER(iwp)                                   ::  win_gridsurf     !< MPI RMA window for reverse grid surface index
 #endif
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  lad_s_ray        !< array of received lad_s for appropriate gridboxes crossed by ray
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  target_surfl
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  rt2_track
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rt2_track_lad
@@ -1083,6 +1141,7 @@
 !-- Public variables and constants / NEEDS SORTING
     PUBLIC albedo, albedo_type, decl_1, decl_2, decl_3, dots_rad, dt_radiation,&
-           emissivity, force_radiation_call,                                   &
-           lat, lon, rad_net_av, radiation, radiation_scheme, rad_lw_in,       &
+           emissivity, force_radiation_call, lat, lon,                         &
+           mrt_include_sw, mrt_nlevels, mrtbl, mrtinsw, mrtinlw, nmrtbl,       &
+           rad_net_av, radiation, radiation_scheme, rad_lw_in,                 &
            rad_lw_in_av, rad_lw_out, rad_lw_out_av,                            &
            rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av, rad_sw_in,  &
@@ -1091,17 +1150,18 @@
            skip_time_do_radiation, time_radiation, unscheduled_radiation_calls,&
            zenith, calc_zenith, sun_direction, sun_dir_lat, sun_dir_lon,       &
-           nrefsteps, mrt_factors, dist_max_svf, nsvfl, svf,                   &
+           write_svf_on_init, read_svf_on_init,                                &
+           nrefsteps, dist_max_svf, nsvfl, svf,                                &
            svfsurf, surfinsw, surfinlw, surfins, surfinl, surfinswdir,         &
            surfinswdif, surfoutsw, surfoutlw, surfinlwdif, rad_sw_in_dir,      &
            rad_sw_in_diff, rad_lw_in_diff, surfouts, surfoutl, surfoutsl,      &
-           surfoutll, idir, jdir, kdir, id, iz, iy, ix, nsurfs, surfstart,     &
+           surfoutll, idir, jdir, kdir, id, iz, iy, ix,                        &
            surf, surfl, nsurfl, pcbinswdir, pcbinswdif, pcbinsw, pcbinlw,      &
-           iup_u, inorth_u, isouth_u, ieast_u, iwest_u,           &
+           iup_u, inorth_u, isouth_u, ieast_u, iwest_u,                        &
            iup_l, inorth_l, isouth_l, ieast_l, iwest_l,                        &
-           nsurf_type, nzub, nzut, nzu, pch, nsurf,                            &
-           iup_a, idown_a, inorth_a, isouth_a, ieast_a, iwest_a,               &
+           nsurf_type, nzub, nzut, nzpt, nzu, pch, nsurf,                      &
            idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct,                             &
            radiation_interactions, startwall, startland, endland, endwall,     &
-           skyvf, skyvft, radiation_interactions_on, average_radiation
+           skyvf, skyvft, radiation_interactions_on, average_radiation, npcbl, &
+           pcbl
 
 #if defined ( __rrtmg )
@@ -1163,5 +1223,5 @@
        SELECT CASE ( TRIM( var ) )
 
-         CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr', 'rad_sw_hr', 'rad_sw_in' )
+          CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr', 'rad_sw_hr', 'rad_sw_in' )
              IF (  .NOT.  radiation  .OR.  radiation_scheme /= 'rrtmg' )  THEN
                 message_string = '"output of "' // TRIM( var ) // '" requi' // &
@@ -1205,4 +1265,26 @@
              IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = '' 
 
+          CASE ( 'rad_mrt', 'rad_mrt_sw', 'rad_mrt_lw'  )
+             IF ( .NOT.  radiation ) THEN
+                message_string = 'output of "' // TRIM( var ) // '" require'&
+                                 // 's radiation = .TRUE.'
+                CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+             ENDIF
+             IF ( mrt_nlevels == 0 ) THEN
+                message_string = 'output of "' // TRIM( var ) // '" require'&
+                                 // 's mrt_nlevels > 0'
+                CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
+             ENDIF
+             IF ( TRIM( var ) == 'rad_mrt_sw'  .AND.  .NOT. mrt_include_sw ) THEN
+                message_string = 'output of "' // TRIM( var ) // '" require'&
+                                 // 's rad_mrt_sw = .TRUE.'
+                CALL message( 'check_parameters', 'PA0511', 1, 2, 0, 6, 0 )
+             ENDIF
+             IF ( TRIM( var ) == 'rad_mrt' ) THEN
+                unit = 'K'
+             ELSE
+                unit = 'W m-2'
+             ENDIF
+
           CASE DEFAULT
              unit = 'illegal'
@@ -1457,4 +1539,14 @@
           ENDIF
        ENDIF
+!
+!--    Parallel rad_angular_discretization without raytrace_mpi_rma is not implemented
+#if defined( __parallel )      
+       IF ( rad_angular_discretization  .AND.  .NOT. raytrace_mpi_rma )  THEN
+          message_string = 'rad_angular_discretization can only be used ' //  &
+                           'together with raytrace_mpi_rma or when ' //  &
+                           'no parallelization is applied.'
+          CALL message( 'check_parameters', 'PA0486', 1, 2, 0, 6, 0 )
+       ENDIF
+#endif
 
        IF ( cloud_droplets  .AND.   radiation_scheme == 'rrtmg'  .AND.         &
@@ -2354,5 +2446,5 @@
 !--    In case averaged radiation is used, calculate mean temperature and 
 !--    liquid water mixing ratio at the urban-layer top.
-       IF ( average_radiation ) THEN   
+       IF ( average_radiation ) THEN
           pt1   = 0.0_wp
           IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1   = 0.0_wp
@@ -2364,6 +2456,16 @@
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( bulk_cloud_model  .OR.  cloud_droplets )                            &
-             CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_AllReduce1:', ierr, pt1_l, pt1
+              FLUSH(9)
+          ENDIF
+
+          IF ( bulk_cloud_model  .OR.  cloud_droplets ) THEN
+              CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+              IF ( ierr /= 0 ) THEN
+                  WRITE(9,*) 'Error MPI_AllReduce2:', ierr, ql1_l, ql1
+                  FLUSH(9)
+              ENDIF
+          ENDIF
 #else
           pt1 = pt1_l 
@@ -2534,6 +2636,15 @@
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( bulk_cloud_model  .OR.  cloud_droplets )                             &
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_AllReduce3:', ierr, pt1_l, pt1
+              FLUSH(9)
+          ENDIF
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
              CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+             IF ( ierr /= 0 ) THEN
+                 WRITE(9,*) 'Error MPI_AllReduce4:', ierr, ql1_l, ql1
+                 FLUSH(9)
+             ENDIF
+          ENDIF
 #else
           pt1 = pt1_l
@@ -2756,24 +2867,33 @@
                                   albedo_lw_dif, albedo_sw_dir, albedo_sw_dif, &
                                   constant_albedo, dt_radiation, emissivity,   &
-                                  lw_radiation, net_radiation,                 &
+                                  lw_radiation, mrt_nlevels, mrt_skip_roof,    &
+                                  mrt_include_sw,  net_radiation,              &
                                   radiation_scheme, skip_time_do_radiation,    &
                                   sw_radiation, unscheduled_radiation_calls,   &
+                                  read_svf_on_init, write_svf_on_init,         &
                                   max_raytracing_dist, min_irrf_value,         &
-                                  nrefsteps, mrt_factors, rma_lad_raytrace,    &
+                                  nrefsteps, raytrace_mpi_rma,                 &
                                   dist_max_svf,                                &
                                   surface_reflections, svfnorm_report_thresh,  &
-                                  radiation_interactions_on
+                                  radiation_interactions_on,                   &
+                                  rad_angular_discretization,                  &
+                                  raytrace_discrete_azims,                     &
+                                  raytrace_discrete_elevs
    
        NAMELIST /radiation_parameters/   albedo, albedo_type, albedo_lw_dir,   &
                                   albedo_lw_dif, albedo_sw_dir, albedo_sw_dif, &
                                   constant_albedo, dt_radiation, emissivity,   &
-                                  lw_radiation, net_radiation,                 &
+                                  lw_radiation, mrt_nlevels, mrt_skip_roof,    &
+                                  mrt_include_sw,  net_radiation,              &
                                   radiation_scheme, skip_time_do_radiation,    &
                                   sw_radiation, unscheduled_radiation_calls,   &
                                   max_raytracing_dist, min_irrf_value,         &
-                                  nrefsteps, mrt_factors, rma_lad_raytrace,    &
+                                  nrefsteps, raytrace_mpi_rma,                 &
                                   dist_max_svf,                                &
                                   surface_reflections, svfnorm_report_thresh,  &
-                                  radiation_interactions_on
+                                  radiation_interactions_on,                   &
+                                  rad_angular_discretization,                  &
+                                  raytrace_discrete_azims,                     &
+                                  raytrace_discrete_elevs
    
        line = ' '
@@ -4456,4 +4576,5 @@
      INTEGER(iwp)                      :: i, j, k, kk, is, js, d, ku, refstep, m, mm, l, ll
      INTEGER(iwp)                      :: isurf, isurfsrc, isvf, icsf, ipcgb
+     INTEGER(iwp)                      :: imrt, imrtf
      INTEGER(iwp)                      :: isd                !< solar direction number
      INTEGER(iwp)                      :: pc_box_dimshift    !< transform for best accuracy
@@ -4547,4 +4668,9 @@
      surfoutsl(:)  = 0.0_wp !start-end
      surfoutll(:)  = 0.0_wp !start-end
+     IF ( nmrtbl > 0 )  THEN
+        mrtinsw(:) = 0._wp
+        mrtinlw(:) = 0._wp
+     ENDIF
+
 
 !--  Set up thermal radiation from surfaces
@@ -4623,4 +4749,9 @@
      CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
                          surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr) !nsurf global
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllGatherv1:', ierr, SIZE(surfoutll), nsurfl, &
+                     SIZE(surfoutl), nsurfs, surfstart
+         FLUSH(9)
+     ENDIF
 #else
      surfoutl(:) = surfoutll(:) !nsurf global
@@ -4639,8 +4770,20 @@
         ENDDO
      ENDIF
-
-     !-- diffuse radiation using sky view factor, TODO: homogeneous rad_*w_in_diff because now it depends on no. of processors
-     surfinswdif(:) = rad_sw_in_diff(nyn,nxl) * skyvft(:)
-     surfinlwdif(:) = rad_lw_in_diff(nyn,nxl) * skyvf(:)
+!
+!--  diffuse radiation using sky view factor
+     DO isurf = 1, nsurfl
+        j = surfl(iy, isurf)
+        i = surfl(ix, isurf)
+        surfinswdif(isurf) = rad_sw_in_diff(j,i) * skyvft(isurf)
+        surfinlwdif(isurf) = rad_lw_in_diff(j,i) * skyvf(isurf)
+     ENDDO
+!
+!--  MRT diffuse irradiance
+     DO  imrt = 1, nmrtbl
+        j = mrtbl(iy, imrt)
+        i = mrtbl(ix, imrt)
+        mrtinsw(imrt) = mrtskyt(imrt) * rad_sw_in_diff(j,i)
+        mrtinlw(imrt) = mrtsky(imrt) * rad_lw_in_diff(j,i)
+     ENDDO
 
      !-- direct radiation
@@ -4654,7 +4797,24 @@
         isd = dsidir_rev(j, i)
         DO isurf = 1, nsurfl
-           surfinswdir(isurf) = rad_sw_in_dir(nyn,nxl) * costheta(surfl(id, isurf)) * dsitrans(isurf, isd) / zenith(0)
+           j = surfl(iy, isurf)
+           i = surfl(ix, isurf)
+           surfinswdir(isurf) = rad_sw_in_dir(j,i) * costheta(surfl(id, isurf)) * dsitrans(isurf, isd) / zenith(0)
+        ENDDO
+!
+!--     MRT direct irradiance
+        DO  imrt = 1, nmrtbl
+           j = mrtbl(iy, imrt)
+           i = mrtbl(ix, imrt)
+           mrtinsw(imrt) = mrtinsw(imrt) + mrtdsit(imrt, isd) * rad_sw_in_dir(j,i) &
+                                     / zenith(0) / 4._wp ! normal to sphere
         ENDDO
      ENDIF
+!
+!--  MRT first pass thermal
+     DO  imrtf = 1, nmrtf
+        imrt = mrtfsurf(1, imrtf)
+        isurfsrc = mrtfsurf(2, imrtf)
+        mrtinlw(imrt) = mrtinlw(imrt) + mrtf(imrtf) * surfoutl(isurfsrc)
+     ENDDO
 
      IF ( npcbl > 0 )  THEN
@@ -4674,5 +4834,5 @@
              IF ( isurfsrc == -1 )  THEN
 !--                 Diffuse rad from sky.
-                 pcbinswdif(ipcgb) = csf(1,icsf) * csf(2,icsf) * rad_sw_in_diff(j,i)
+                 pcbinswdif(ipcgb) = csf(1,icsf) * rad_sw_in_diff(j,i)
 
                  !--Direct rad
@@ -4685,6 +4845,4 @@
                                         * pc_abs_frac * dsitransc(ipcgb, isd)
                  ENDIF
-
-                 EXIT ! only isurfsrc=-1 is processed here
              ENDIF
          ENDDO
